import helper.BloodTypeServices;

import java.io.IOException;
import java.util.Scanner;
import type.lib.ToolBox;

public class Labtest12_Sec02_Part1 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) {

		/**
		 * GOAL: write a program that prompts the user for a particular type of
		 * input, parses that input and produces an output that matches the
		 * specification. App gives specific error messages in the case of
		 * invalid input.
		 */

		/**
		 * There are four different blood types: A, B, AB, and O. The blood type
		 * of a child is inherited from both parents and depends on various
		 * factors (such as specific alleles). The particular combination of
		 * blood types of the parents determine a small range of possible blood
		 * types for the offspring. In this app, the user can query to see
		 * whether a given child's blood type is genetically consistent with the
		 * blood types of the biological parents
		 * 
		 * [1 mark] Step 1: Read the string that the user enters in response to
		 * the provided prompt. Store it in an appropriately named variable.
		 */
		String PROMPT = "Enter a string of the form m|f|c,\n"
				+ "where m is the blood type of the mother (m=A,B,AB,O),\n"
				+ "f is the blood type of the father (f=A,B,AB,O), and\n"
				+ "c is the blood type of the child (c=A,B,AB,O): ";
		// eg A|B|AO or A|O|O or AB|AB|AB

		/**
		 * [2 marks] Step 2: Parse the user input to string values for the "m",
		 * "f", and "c" components. Use the vertical bar "|" as the basis for
		 * parsing using the indexOf/substring methods as in fig 11.4. (There
		 * are several other methods for doing this). For this step, you can
		 * assume the user input is well formed. Hint: to find the index of the
		 * second vertical bar, have a look at the method with the signature
		 * indexOf(String, int). Print out each of the three string values to
		 * System.out
		 */

		/**
		 * [2 marks] Step 3: Add a try-catch block around the code from step 2
		 * above so that if the user neglects to include the two vertical bars
		 * so that the string cannot be parsed into the three components, the
		 * message "Missing separator!" is printed and the app finishes (without
		 * crashing).
		 */

		/**
		 * [3 marks] Step 4: Add to the code developed in Step 3. Within the try
		 * block, add an if clause to test whether the m, f, and c components
		 * are valid blood types. The validity test should be case insensitive
		 * (e.g., A, B, AB, O, a, b, ab, o are all acceptable). If any of the
		 * three components do not, use one of the two techniques for throwing
		 * an exception as described in Example 11.3. The file type.jar has been
		 * included in this project so that you may use the services of ToolBox,
		 * if you desire. In such cases, the message "Invalid blood type!"
		 * should be printed and the app finishes (without crashing).
		 */

		/**
		 * [3 marks] Step 5: Add to the code developed in Step 4. Use the
		 * services of BloodTypeServices.isCompatible(String, String, String) to
		 * determine whether the blood type of the child is consistent with the
		 * blood types of the parents. The API for this class is found in the
		 * "doc" folder of this package. Provide feedback to the user
		 * accordinginly "Child bloodtype is consistent with parent blood types"
		 * or "Child bloodtype is not consistent with parent blood types".
		 * 
		 */

		/**
		 * [2 marks] Step 6, Bonus: Inspect the API for
		 * BloodTypeServices.isCompatible carefully. Is there a modification
		 * that could be made to your code to remove the validation that was
		 * done in Step 4? Create a copy of the code from Step 5 and comment it
		 * out. Then modify the code accordingly.
		 */

	}
}
